---
title: "FreeBSD 8.0-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008, 2009 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: stable/8/release/doc/en_US.ISO8859-1/relnotes/article.sgml
199849 2009-11-26 22:09:37Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN27" name="AEN27"></a>
<p>The release notes for FreeBSD 8.0-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 8-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 8.0-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 8.0-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 8.0-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
7.0-RELEASE, and changes shown in Release Notes for the previous releases are marked as
<tt class="LITERAL">[7.1R]</tt> and <tt class="LITERAL">[7.2R]</tt>.</p>

<p>Typical release note items document recent security advisories issued after
7.0-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN49" name="AEN49"></a>
<table border="0" frame="void" class="CALSTABLE">
<col width="1*" />
<col width="1*" />
<col width="3*" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:05.openssh.asc"
target="_top">SA-08:05.openssh</a></td>
<td>17&nbsp;April&nbsp;2008</td>
<td>
<p>OpenSSH X11-forwarding privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:06.bind.asc"
target="_top">SA-08:06.bind</a></td>
<td>13&nbsp;July&nbsp;2008</td>
<td>
<p>DNS cache poisoning</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:07.amd64.asc"
target="_top">SA-08:07.amd64</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p>amd64 swapgs local privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:08.nmount.asc"
target="_top">SA-08:08.nmount</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nmount&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nmount</span>(2)</span></a> local
arbitrary code execution</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:09.icmp6.asc"
target="_top">SA-08:09.icmp6</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p>Remote kernel panics on IPv6 connections</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:10.nd6.asc"
target="_top">SA-08:10.nd6</a></td>
<td>1&nbsp;October&nbsp;2008</td>
<td>
<p>IPv6 Neighbor Discovery Protocol routing vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:11.arc4random.asc"
target="_top">SA-08:11.arc4random</a></td>
<td>24&nbsp;November&nbsp;2008</td>
<td>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arc4random&sektion=9&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arc4random</span>(9)</span></a>
predictable sequence vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:12.ftpd.asc"
target="_top">SA-08:12.ftpd</a></td>
<td>23&nbsp;December&nbsp;2008</td>
<td>
<p>Cross-site request forgery in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ftpd</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:13.protosw.asc"
target="_top">SA-08:13.protosw</a></td>
<td>23&nbsp;December&nbsp;2008</td>
<td>
<p>netgraph / bluetooth privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:01.lukemftpd.asc"
target="_top">SA-09:01.lukemftpd</a></td>
<td>07&nbsp;January&nbsp;2009</td>
<td>
<p>Cross-site request forgery in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lukemftpd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lukemftpd</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:02.openssl.asc"
target="_top">SA-09:02.openssl</a></td>
<td>07&nbsp;January&nbsp;2009</td>
<td>
<p>OpenSSL incorrectly checks for malformed signatures</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:03.ntpd.asc"
target="_top">SA-09:03.ntpd</a></td>
<td>13&nbsp;January&nbsp;2009</td>
<td>
<p>ntpd cryptographic signature bypass</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:04.bind.asc"
target="_top">SA-09:04.bind</a></td>
<td>13&nbsp;January&nbsp;2009</td>
<td>
<p>BIND DNSSEC incorrect checks for malformed signatures</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:05.telnetd.asc"
target="_top">SA-09:05.telnetd</a></td>
<td>16&nbsp;February&nbsp;2009</td>
<td>
<p>telnetd code execution vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:06.ktimer.asc"
target="_top">SA-09:06.ktimer</a></td>
<td>23&nbsp;March&nbsp;2009</td>
<td>
<p>Local privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:07.libc.asc"
target="_top">SA-09:07.libc</a></td>
<td>04&nbsp;April&nbsp;2009</td>
<td>
<p>Information leak in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=db&sektion=3&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">db</span>(3)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:08.openssl.asc"
target="_top">SA-09:08.openssl</a></td>
<td>22&nbsp;April&nbsp;2009</td>
<td>
<p>Remotely exploitable crash in OpenSSL</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:09.pipe.asc"
target="_top">SA-09:09.pipe</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>Local information disclosure via direct pipe writes</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:10.ipv6.asc"
target="_top">SA-09:10.ipv6</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>Missing permission check on SIOCSIFINFO_IN6 ioctl</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:11.ntpd.asc"
target="_top">SA-09:11.ntpd</a></td>
<td>10&nbsp;June&nbsp;2009</td>
<td>
<p>ntpd stack-based buffer-overflow vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:12.bind.asc"
target="_top">SA-09:12.bind</a></td>
<td>29&nbsp;July&nbsp;2009</td>
<td>
<p>BIND <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> dynamic
update message remote DoS</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:14.devfs.asc"
target="_top">SA-09:14.devfs</a></td>
<td>2&nbsp;Oct&nbsp;2009</td>
<td>
<p>Devfs / VFS NULL pointer race condition</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The FreeBSD <tt class="FILENAME">GENERIC</tt> kernel now includes Trusted BSD MAC
(Mandatory Access Control) support. No MAC policy module is loaded by default.</p>

<p>[i386] A loader tunable <code class="VARNAME">hw.clflush_disable</code> has been added
to avoid panic (trap 9) at <code class="FUNCTION">map_invalidate_cache_range()</code>
even if Intel CPU is used. This tunable can be set to <tt class="LITERAL">-1</tt>
(default), <tt class="LITERAL">0</tt> and <tt class="LITERAL">1</tt>. The <tt
class="LITERAL">-1</tt> is same as the current behavior, which automatically disables <tt
class="LITERAL">CLFLUSH</tt> on Intel CPUs without <tt class="LITERAL">CPUID_SS</tt>
(this should occurr on Xen only). You can specify <tt class="LITERAL">1</tt> when this
panic happens on non-Intel CPUs (such as AMD's). Because disabling <tt
class="LITERAL">CLFLUSH</tt> can reduce performance, you can try with setting <tt
class="LITERAL">0</tt> on Intel CPUs without <tt class="LITERAL">SS</tt> to use <tt
class="LITERAL">CLFLUSH</tt> feature.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>
subsystem has been updated. Changes include:</p>

<ul>
<li>
<p>A new virtualization container named &#8220;vimage&#8221; has been implemented. This
is not enabled by default. To enable this, add the following kernel options to your
kernel configuration file and rebuild the kernel:</p>

<pre class="PROGRAMLISTING">
options    VIMAGE
</pre>

<p>Note that <tt class="LITERAL">options SCTP</tt> in the <tt
class="FILENAME">GENERIC</tt> kernel is not compatible with <tt class="LITERAL">options
VIMAGE</tt>. This limitation will be fixed in the next release.</p>

<p>The vimage is a jail with a virtualized instance of the FreeBSD network stack. It can
be created by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> command
like this:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> jail -c vnet name=<tt
class="REPLACEABLE"><i>vnet1</i></tt> host.hostname=<tt
class="REPLACEABLE"><i>vnet1.example.net</i></tt> path=/ persist
</pre>

<p>The vimage has own loopback interface and a separated network stack including the L3
routing tables. Network interfaces on the system can be moved by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
<code class="OPTION">vnet</code> option between the different vimage jails and outside of
them.</p>

<p>Furthermore, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=epair&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">epair</span>(4)</span></a>
pseudo-interface driver has been added to help communication between vimage jails. It
emulates a pair of back-to-back connected Ethernet interfaces. For example, the following
commands create an interface pair of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=epair&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">epair</span>(4)</span></a>:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> ifconfig epair0 create
epair0a
<samp class="PROMPT">#</samp> ifconfig epair0a
epair0a: flags=8842&lt;BROADCAST,RUNNING,SIMPLEX,MULTICAST&gt; metric 0 mtu 1500
    ether 02:c0:64:00:07:0a
<samp class="PROMPT">#</samp> ifconfig epair0b
epair0b: flags=8842&lt;BROADCAST,RUNNING,SIMPLEX,MULTICAST&gt; metric 0 mtu 1500
    ether 02:c0:64:00:08:0b
</pre>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=epair&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">epair</span>(4)</span></a>
pseudo-interfaces and any physical interfaces on the system can be moved between vimage
jails by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
<code class="OPTION">vnet</code> option as described above. Even after half of an <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=epair&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">epair</span>(4)</span></a> pair is
moved, the back-to-back connection still valid and can be used for inter-jail
communication.</p>

<p>Note that vimage is still considered as an experimental feature.</p>
</li>

<li>
<p>A jail can now have arbitrary named parameters similar to environmental variables and
the fixed jail parameters in the previous releases have been replaced with them. The jail
name can now be used for identifying the jail in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jexec&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jexec</span>(8)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=killall&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">killall</span>(1)</span></a>.</p>
</li>

<li>
<p>Multiple IPv4 and/or IPv6 addresses per jail are now supported. It is even possible to
have jails without an IP address at all, which basically gives one a chrooted environment
with restricted process view and no networking.</p>
</li>

<li>
<p>SCTP (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sctp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sctp</span>(4)</span></a>) with
IPv6 in jails has been implemented.</p>
</li>

<li>
<p>Specific CPU binding by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(1)</span></a> has
been implemented. Note that the current implementation allows the superuser inside of the
jail to change the CPU bindings specified.</p>
</li>

<li>
<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> can
start with a specific route FIB now.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> kernel
debugger now supports a <tt class="LITERAL">show jails</tt> subcommand.</p>
</li>

<li>
<p>Compatibility support which permits 32-bit jail binaries to be used on 64-bit systems
to manage jails has been added.</p>
</li>

<li>
<p>Note that both version numbers of <tt class="LITERAL">jail</tt> and <tt
class="LITERAL">prison</tt> in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> have
been updated for the new features.</p>
</li>
</ul>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ksyms&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ksyms</span>(4)</span></a>, kernel
symbol table interface driver has been added. It creates a character device <tt
class="FILENAME">/dev/ksyms</tt> and provides read-only access to a snapshot of the
kernel symbol table.</p>

<p>[amd64, i386] The FreeBSD Linux emulation layer has been updated to version 2.6.16 and
the default Linux infrastructure port is <tt
class="FILENAME">emulators/linux_base-f10</tt> (Fedora 10).</p>

<p>[arm] The FreeBSD/arm now supports mini dump.</p>

<p>[powerpc] The FreeBSD/powerpc now supports kernel core dump.</p>

<p>[amd64, i386] The FreeBSD virtual memory subsystem now supports fully transparent use
of <b class="APPLICATION">superpages</b> for application memory; application memory pages
are dynamically promoted to or demoted from superpages without any modification to
application code. This change offers the benefit of large page sizes such as improved
virtual memory efficiency and reduced TLB (translation lookaside buffer) misses without
downsides like application changes and virtual memory inflexibility. This can be enabled
by setting a loader tunable <code class="VARNAME">vm.pmap.pg_ps_enabled</code> to <tt
class="LITERAL">1</tt> and is enabled by default on amd64.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> kernel
debugger now supports a <tt class="COMMAND">show mount</tt> subcommand.</p>

<p>[7.2R] The FreeBSD DTrace subsystem now supports a probe for process execution.</p>

<p>[7.2R] [amd64] The FreeBSD kernel virtual address space has been increased to 6GB.
This allows subsystems to use larger virtual memory space than before. For example, the
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">zfs</span>(8)</span></a> adaptive
replacement cache (ARC) requires large kernel memory space to cache file system data, so
it benefits from the increased address space. Note that the ceiling on the kernel map
size is now 60% of the size of physical memory rather than an absolute quantity.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> now
supports installing 32-bit system calls to the FreeBSD syscall translation layer from
kernel modules.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ktr&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ktr</span>(4)</span></a> now
supports a new KTR tracepoint in the <tt class="LITERAL">KTR_CALLOUT</tt> class to note
when a callout routine finishes executing.</p>

<p>[7.2R] Types of variables used to track the amount of allocated System V shared memory
have been changed from <tt class="LITERAL">int</tt> to <tt class="LITERAL">size_t</tt>.
This makes it possible to use more than 2 GB of memory for shared memory segments on
64-bit architectures. Please note the new BUGS section in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shmctl&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">shmctl</span>(2)</span></a> and
<tt class="FILENAME">/usr/src/UPDATING</tt> for limitations of this temporary
solution.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(3)</span></a> leaf
nodes have a flag to tag themselves as MPSAFE now.</p>

<p>[7.2R] The FreeBSD 32-bit system call translation layer now supports installing 32-bit
system calls for <tt class="LITERAL">VFS_AIO</tt>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clock_gettime&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clock_gettime</span>(2)</span></a>
and the related system calls now support a clock ID <tt
class="LITERAL">CLOCK_THREAD_CPUTIME_ID</tt>, as defined in POSIX.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(2)</span></a> system
call has been added. This is an API for thread to CPU binding and CPU resource grouping
and assignment.</p>

<p>[7.1R] The DTrace, a comprehensive dynamic tracing framework and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dtrace&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dtrace</span>(1)</span></a>
userland utility have been imported from OpenSolaris. DTrace provides a powerful
infrastructure to permit administrators, developers, and service personnel to concisely
answer arbitrary questions about the behavior of the operating system and user
programs.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> kernel
debugger now has an output capture facility. Input and output from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> can now
be captured to a memory buffer for later inspection using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a> or a
textdump. The new <tt class="COMMAND">capture</tt> command controls this feature.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> debugger
now supports a simple scripting facility, which supports a set of named scripts
consisting of a set of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> commands.
These commands can be managed from within <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> or with
the use of the new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> utility.
More details can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> manual
page.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> <tt
class="COMMAND">ex</tt> command now supports an <code class="OPTION">/S</code> mode which
interprets and prints the value at the requested address as a symbol. For example, <kbd
class="USERINPUT">ex /S <tt class="REPLACEABLE"><i>aio_swake</i></tt></kbd> prints the
name of the function currently registered in via <tt
class="REPLACEABLE"><i>aio_swake</i></tt> hook.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> <tt
class="COMMAND">show conifhk</tt> command has been added. This lists hooks currently
waiting for completion in <code
class="FUNCTION">run_interrupt_driven_config_hooks()</code>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fcntl&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fcntl</span>(2)</span></a> system
call now supports <tt class="LITERAL">F_DUP2FD</tt> command. This is equivalent to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dup&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dup</span>(2)</span></a>, and
compatible with the Sun Solaris and the IBM AIX.</p>

<p>[7.1R] The FreeBSD's <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linux&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linux</span>(4)</span></a> ABI
support now implements <code class="FUNCTION">sched_setaffinity()</code> and <code
class="FUNCTION">sched_getaffinity()</code> using real CPU affinity setting
primitives.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procstat</span>(1)</span></a>
utility has been added. This is a process inspection utility which provides some of the
missing functionality from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procfs&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procfs</span>(5)</span></a> and
new functionality for monitoring and debugging specific processes.</p>

<p>[7.1R] The client side functionality of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.lockd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.lockd</span>(8)</span></a> has
been implemented in the FreeBSD kernel. This implementation provides the correct
semantics for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=flock&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">flock</span>(2)</span></a> style
locks which are used by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lockf&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lockf</span>(1)</span></a> command
line tool and the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pidfile&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pidfile</span>(3)</span></a>
library. It also implements recovery from server restarts and ensures that dirty cache
blocks are written to the server before obtaining locks (allowing multiple clients to use
file locking to safely share data). Also, a new kernel option <tt class="LITERAL">options
NFSLOCKD</tt> has been added and enabled by default. If the kernel support is enabled, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.lockd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.lockd</span>(8)</span></a>
automatically detects and uses the functionality.</p>

<p>[7.1R] The FreeBSD kernel now supports a new textdump format of kernel dumps. A
textdump provides higher-level information via mechanically generated/extracted debugging
output, rather than a simple memory dump. This facility can be used to generate brief
kernel bug reports that are rich in debugging information, but are not dependent on
kernel symbol tables or precisely synchronized source code. More information can be found
in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=textdump&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">textdump</span>(4)</span></a>
manual page.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wait4&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wait4</span>(2)</span></a> system
call now supports <code class="OPTION">WNOWAIT</code> flag to keep the process whose
status is returned in a waitable state and <code class="OPTION">WSTOPPED</code> which is
equivalent to <code class="OPTION">WUNTRACED</code>.</p>

<p>[7.1R] [amd64, i386, sparc64] The FreeBSD kernel now has initial support of binding
interrupts to CPUs.</p>

<p>[7.1R] [amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>
scheduler is now the default process scheduler in <tt class="FILENAME">GENERIC</tt>
kernels.</p>

<p>[7.1R] The sysctl variables <code
class="VARNAME">kern.features.compat_freebsd[456]</code> have been added. These are
corresponding to the kernel options <tt class="LITERAL">COMPAT_FREEBSD[456]</tt>.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>The <b class="APPLICATION">boot0</b> boot loader now preserves volume ID at offset
0x1b8 used in other operating systems</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot0cfg&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">boot0cfg</span>(8)</span></a>
utility now supports a new <code class="OPTION">-i</code> option to set the volume
ID.</p>

<p>[arm, powerpc] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> now
supports U-Boot support library.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">boot</span>(8)</span></a> now
supports 4-byte volume ID that certain versions of <span
class="TRADEMARK">Windows</span>&reg; put into the MBR and invoking PXE by pressing the
F6 key on some supported BIOSes.</p>

<p>[7.2R] [i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">boot</span>(8)</span></a> BTX
loader has been improved. This fixes several boot issues on recent machines reported for
7.1-RELEASE and before.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> is now
able to obtain DHCP options from network boot via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kenv&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kenv</span>(2)</span></a>
variables.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> has
been fixed. Now the following line works as expected:</p>

<pre class="PROGRAMLISTING">
loader_conf_files="<tt class="REPLACEABLE"><i>foo</i></tt> <tt
class="REPLACEABLE"><i>bar</i></tt> ${<tt class="REPLACEABLE"><i>variable</i></tt>}"
</pre>

<p>[7.1R] [amd64, i386] The BTX kernel used by the boot loader has been changed to invoke
BIOS routines from real mode. This change makes it possible to boot FreeBSD from USB
devices.</p>

<p>[7.1R] [amd64, i386] A new gptboot boot loader has been added to support booting from
a GPT labeled disk. A new <tt class="COMMAND">boot</tt> command has been added to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a>, which
makes a GPT disk bootable by writing the required bits of the boot loader, creating a new
boot partition if required.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>The FreeBSD now includes experimental support for MIPS platform.</p>

<p>Support for RTC on Dallas Semiconductor chips has been improved. The DS133x and DS1553
are now supported.</p>

<p>[arm] The FreeBSD/arm now supports Feroceon and Sheeva embedded CPU, Marvell Orion
(88F5281), Kirkwood (88F6281), Discovery Innovation (MV-78100) systems-on-chip CPU.</p>

<p>[powerpc] The FreeBSD/powerpc now supports SMP machines</p>

<p>[powerpc] The FreeBSD/powerpc now supports E500 (Book-E) embedded CPU and Freescale
PowerQUICCIII MPC85xx system-on-chip (including single and dual-core).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi</span>(4)</span></a>
subsystem now supports the System Resource Affinity Table (SRAT) used to describe
affinity relationships between CPUs and memory, ACPI 3.0 fields in the MADT including
X2APIC entries and UIDs for local SAPICs, and ACPI 3.0 flags in the FADT.</p>

<p>[powerpc] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
framework now supports PowerPC G5, along with a skeleton SMU driver in order to slew CPU
voltage during frequency changes.</p>

<p>The sec(4) driver has been added to provide support for the integrated security engine
found in Freescale system-on-chip devices.</p>

<p>The FreeBSD TTY layer has been replaced with a new one which has better support for
SMP and robust resource handling. A tty now has own mutex and it is expected to improve
scalability when compared to the old implementation based on the Giant lock.</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uart</span>(4)</span></a> driver
is now the default driver for serial port devices in favor of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sio&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sio</span>(4)</span></a> driver.
Note that the device nodes have been renamed from <tt class="FILENAME">/dev/cuad<tt
class="REPLACEABLE"><i>N</i></tt></tt> and <tt class="FILENAME">/dev/ttyd<tt
class="REPLACEABLE"><i>N</i></tt></tt> to <tt class="FILENAME">/dev/cuau<tt
class="REPLACEABLE"><i>N</i></tt></tt> and <tt class="FILENAME">/dev/ttyu<tt
class="REPLACEABLE"><i>N</i></tt></tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Users who are upgrading will need to change their kernel
configurations and possibly also <tt class="FILENAME">/boot/loader.conf</tt> and <tt
class="FILENAME">/boot/device.hints</tt>.</p>
</blockquote>
</div>

<p>The FreeBSD USB subsystem has been reimplemented to support modern devices and better
SMP scalability. The new implementation includes Giant-lock-free device drivers, a Linux
compatibility layer, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=usbconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">usbconfig</span>(8)</span></a>
utility, full support for split transaction and isochronous transaction, and more. Device
node names for USB devices are now in a the form of <tt class="FILENAME">/dev/usb/<tt
class="REPLACEABLE"><i>bus</i></tt>.<tt class="REPLACEABLE"><i>dev</i></tt>.<tt
class="REPLACEABLE"><i>endpoint</i></tt></tt>, and <tt class="FILENAME">/dev/usbctl</tt>
is the master device node. Note that the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ugen&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ugen</span>(4)</span></a> driver
has nodes for each device as <tt class="FILENAME">/dev/ugen<tt
class="REPLACEABLE"><i>bus</i></tt>.<tt class="REPLACEABLE"><i>dev</i></tt></tt> for
backward compatibility.</p>

<p>[7.2R] [sparc64] FreeBSD now supports Ultra SPARC III (Cheetah) processor family.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi</span>(4)</span></a>
subsystem now supports a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">debug.batt.batt_sleep_ms</code>. On some laptops with
smart batteries, enabling battery monitoring software causes keystrokes from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a> to be
lost. This sysctl variable adds a delay in millisecond to the status checking code as a
workaround.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_asus&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_asus</span>(4)</span></a>
driver now supports Asus A8Sr notebooks.</p>

<p>[7.2R] [powerpc] Support for the AltiVec, a floating point and integer SIMD
instruction set has been added.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a>
driver, which provides a special device <tt class="FILENAME">/dev/cpuctl</tt> as an
interface to the system CPU has been added. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a>
functionality includes the ability to retrieve CPUID information, read/write machine
specific registers (MSR), and perform CPU firmware updates.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
driver now supports an <code class="VARNAME">hw.est.msr_info</code> loader tunable. When
this is set to <tt class="LITERAL">1</tt>, it attempts to build a simple list containing
just the high and low frequencies if it cannot obtain a frequency list from either ACPI
or the static tables. This is disabled by default.</p>

<p>[7.2R] [amd64, i386] CPU frequency change notifiers are now disabled when the TSC is
P-state invariant. Also, a new loader tunable <code
class="VARNAME">kern.timecounter.invariant_tsc</code> has been added to force this
behavior by setting it to non-zero.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a> driver
now disables the interrupt handler which is called from the keyboard callback function
when polled mode is enabled. This fixes the problem of duplicated/missing characters at
the mountroot prompt on multi CPU systems while <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> is
enabled.</p>

<p>[7.2R] In the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pci&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pci</span>(4)</span></a> subsystem
INTx is now disabled when MSI/MSIX is enabled. This change fixes interrupt storm related
issues.</p>

<p>[7.2R] [sparc64] The schizo(4) driver for Schizo Fireplane/Safari to PCI 2.1 and
Tomatillo JBus to PCI 2.2 bridges has been added.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=u3g&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">u3g</span>(4)</span></a> driver
for USB based 3G cards and dongles including Vodafone Mobile Connect Card 3G, Qualcomm
CDMA MSM, Huawei E220, Novatel U740, Sierra MC875U, and more has been added. This
provides support for the multiple USB-to-serial interfaces exposed by many 3G USB/PC Card
modems, and the device is accessed through the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ucom&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ucom</span>(4)</span></a> driver
which makes it behave like a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tty&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tty</span>(4)</span></a>.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>
scheduler now supports the loader tunable <code
class="VARNAME">machdep.hyperthreading_enabled</code> just like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_4bsd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_4bsd</span>(4)</span></a>.
Note that it cannot be modified at run-time.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cmx&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cmx</span>(4)</span></a> driver, a
driver for Omnikey CardMan 4040 PCMCIA smartcard readers, has been added.</p>

<p>[7.1R] [sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> driver
now supports sparc64. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sunkbd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sunkbd</span>(4)</span></a> driver
now supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a>
emulation like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ukbd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ukbd</span>(4)</span></a>.</p>

<p>[7.1R] The <tt class="FILENAME">nvram(4)</tt> driver is now MPSAFE.</p>

<p>[7.1R] An option of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=puc&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">puc</span>(4)</span></a> driver,
<tt class="LITERAL">PUC_FASTINTR</tt>, is no longer supported.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=psm&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">psm</span>(4)</span></a> driver
now attempts detection of Synaptics touchpad before IntelliMouse. Some touchpads will
pretend to be IntelliMouse causing the IntelliMouse probe to work and the Synaptics
detection never to be done.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uslcom&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uslcom</span>(4)</span></a>
driver, a driver for Silicon Laboratories CP2101/CP2102-based USB serial adapters, has
been imported from OpenBSD.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p>The FreeBSD audio subsystem has been improved. The changes include volume per channel,
high quality fixed-point band-limited SINC sampling rate converter, bit-perfect mode,
transparent/adaptive virtual channel, and exclusive stream. For more details, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd</span>(4)</span></a> manual
page.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=agp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">agp</span>(4)</span></a> driver
now supports Intel G4X series graphics chipsets.</p>

<p>[7.2R] The Direct Rendering Manager (<b class="APPLICATION">DRM</b>), a kernel module
that gives direct hardware access to DRI clients, has been updated. Support for AMD/ATI
r500, r600, r700, and IGP based chips, XGI V3XE/V5/V8, and Intel i915 chipsets has been
improved.</p>

<p>[7.2R] A new loader tunable <code class="VARNAME">hw.drm.msi</code> has been added to
control if DRM uses MSI or not. This is set to <tt class="LITERAL">1</tt> (enabled) by
default.</p>

<p>[7.2R] The snd_au88x0(4) driver for Aureal Vortex 1/2/Advantage PCI has been removed
because it has been broken for a long time.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_hda&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_hda</span>(4)</span></a>
driver has been updated. These changes include support for multiple codecs per HDA bus,
multiple functional groups per codec, multiple audio devices per functional group,
digital (SPDIF/HDMI) audio input/output, suspend/resume, and part of multichannel
audio.</p>

<p>[7.2R] Note that due to added HDMI audio and logical audio devices support, the
updated driver often provides several PCM devices. This means that in some cases the
system default audio device no longer corresponds to the users's habitual audio
connectors. In such cases the default device can be specified in audio applications'
setup or defined globally via <code class="VARNAME">hw.snd.default_unit</code> sysctl
variable, as described in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sound&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sound</span>(4)</span></a> manual
page.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=agp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">agp</span>(4)</span></a> driver
now supports the Intel G33 and G45.</p>

<p>[7.1R] [i386] The <tt class="FILENAME">dpms(4)</tt> driver has been added to use the
VESA BIOS for DPMS during suspend and resume.</p>

<p>[7.1R] The <b class="APPLICATION">DRM</b> kernel driver now supports i915 GME
devices.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bwi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bwi</span>(4)</span></a> driver
has been added to provide support for Broadcom BCM43xx IEEE 802.11b/g wireless network
interfaces.</p>

<p>[sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cas&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cas</span>(4)</span></a> driver
has been added to provide support for Sun Cassini/Cassini+ and National Semiconductor
DP83065 Saturn Gigabit Ethernet devices.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgbtool&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgbtool</span>(8)</span></a> now
supports an interactive mode for scripting of repeatedly performed tasks.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver
has been improved. Changes include:</p>

<ul>
<li>
<p>The multicast filter re-programming is now more robust.</p>
</li>

<li>
<p>[7.2R] The checksum offload feature can be controlled by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
now.</p>
</li>

<li>
<p>[7.2R] Rx checksum offload support for 82559 or later controllers has been added.</p>
</li>

<li>
<p>[7.2R] TSO (TCP Segmentation Offload) support for 82550 and 82551 controllers has been
added.</p>
</li>

<li>
<p>[7.2R] WoL (Wake on LAN) support for 82550, 82551, 82558, and 82559-based controllers
has been added. Note that ICH based controllers are treated as 82559, and 82557, earlier
revisions of 82558, and 82559ER have no WoL capability.</p>
</li>

<li>
<p>[7.2R] VLAN hardware tag insertion/stripping support and Tx/Rx checksum offload for
VLAN frames support has been added. Note that the VLAN hardware assistance is available
only on 82550 or 82551-based controllers.</p>
</li>
</ul>

<p>[arm, powerpc] The mge(4) driver has been added to provide support for Marvell Gigabit
Ethernet controllers found on ARM-based SOCs (Orion, Kirkwood, Discovery), as well as on
system controllers for PowerPC processors (MV64430, MV6446x).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=miibus&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">miibus</span>(4)</span></a> driver
now supports the Marvell 88E3016.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
now supports Yukon FE+ A0 including 88E8040, 88E8040T, 88E8048 and 88E8070.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mwl&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mwl</span>(4)</span></a> driver
has been added to provide support for Marvell 88W8363 IEEE 802.11n wireless network
devices.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
now supports some newer revisions and 10GBASE-LRM and 10GBASE-Twinax media types. The
firmware version has been updated to 1.4.43.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nge&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nge</span>(4)</span></a> driver
has been improved and now works on all platforms.</p>

<p>The tsec(4) driver has been added to provide support for Freescale integrated
Three-Speed Ethernet Controller (TSEC). This driver also works with the enhanced version
of the controller (eTSEC).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uath&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uath</span>(4)</span></a> driver
for USB wireless LAN adapter based on Atheros AR5005UG and AR5005UX chipsets has been
added. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uathload&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uathload</span>(8)</span></a>
utility, a firmware loader for the Atheros USB wireless driver has also been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=urtw&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">urtw</span>(4)</span></a> driver
has been added to provide support for Realtek RTL8187B/L USB IEEE 802.11b/g wireless
network devices.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xl&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">xl</span>(4)</span></a> driver now
supports TX checksum offload.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ae&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ae</span>(4)</span></a> driver now
supports WoL (Wake on LAN).</p>

<p>[7.2R] [amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ale</span>(4)</span></a> driver is
now included in the <tt class="FILENAME">GENERIC</tt> kernel.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath_hal&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath_hal</span>(4)</span></a>,
Atheros Hardware Access Layer, has been updated to the open source version.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=axe&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">axe</span>(4)</span></a> driver
has been improved in performance by eliminating extra context switches and now supports
the Apple USB Ethernet adapter.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> driver's
firmware has been updated to the latest version (4.6.X).</p>

<p>[7.2R] The ciphy(4) driver now supports Vitesse VSC8211 PHY.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a> driver
has been updated to firmware revision 4.7 and now supports hardware MAC statistics.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver,
which prevented the loader tunable <code class="VARNAME">hw.igb.ave_latency</code> from
working, has been fixed.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ixgbe</span>(4)</span></a> driver
has been updated to version 1.7.4.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jme&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jme</span>(4)</span></a> driver
now supports newer JMicron JMC250/JMC260 revisions.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
has been improved. An issue which made it hang up in a certain condition has been fixed.
Hardware MAC statistics support has been added and users can get the information via
sysctl variables named <code class="VARNAME">dev.msk.<tt
class="REPLACEABLE"><i>N</i></tt>.stats</code>.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a> driver
now supports hardware MAC statistics.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver has been
improved. It now detects the link status. A new loader tunable <code
class="VARNAME">hw.re.prefer_iomap</code> has been added, to disable memory register
mapping. This tunable is <tt class="LITERAL">0</tt> for all controllers except RTL8169SC
family.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rl</span>(4)</span></a> driver has been
improved. It now detects the link status and a bug which prevented it from working on
systems with more than 4GB memory has been fixed.</p>

<p>[7.2R] A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a> on VLAN
tagged frame handling has been fixed.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=txp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">txp</span>(4)</span></a> driver
now works on all supported architectures. Support has been added for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>, WoL,
checksum offload when VLAN enabled, and link state change handling has been improved, and
new sysctl variables <code class="VARNAME">dev.txp.<tt
class="REPLACEABLE"><i>N</i></tt>.stats</code> for MAC statistics have been added. New
sysctl variables <code class="VARNAME">dev.txp.<tt
class="REPLACEABLE"><i>N</i></tt>.process_limit</code> has been added, to control how
many received frames should be served in Rx handler (set to 64 by default and valid
ranges are 16 to 128 in unit of frames). The firmware has been updated to the latest
version.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ae&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ae</span>(4)</span></a> driver has been
added to provide support for the Attansic/Atheros L2 FastEthernet controllers.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jme&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jme</span>(4)</span></a> driver
has been added to provide support for PCIe adapters based on JMicron JMC250 gigabit
Ethernet and JMC260 fast Ethernet controllers.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=age&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">age</span>(4)</span></a> driver
has been added to provide support for Attansic/Atheros L1 gigabit Ethernet
controller.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=malo&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">malo</span>(4)</span></a> driver
has been added to provide support for Marvell Libertas 88W8335 based PCI network
adapters.</p>

<p>[7.1R] The bm(4) driver has been added to provide support for Apple Big Mac (BMAC)
Ethernet controller, found on various Apple G3 models.</p>

<p>[7.1R] The et(4) driver has been added to provide support for Agere ET1310
10/100/Gigabit Ethernet controller.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glxsb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glxsb</span>(4)</span></a> driver
has been added to provide support for the Security Block in AMD Geode LX processors.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ale</span>(4)</span></a> driver
has been added to provide support for Atheros AR8121/AR8113/AR8114 Gigabit/Fast Ethernet
controllers. This driver is not enabled in <tt class="FILENAME">GENERIC</tt> kernels for
this release.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver has been
split into two drivers with some common parts. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver will
continue to support adapters up to the 82575, as well as new client/desktop adapters. A
new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver
will support new server adapters.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hme&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hme</span>(4)</span></a> driver
has been improved.</p>

<p>[7.1R] A bug in some of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=miibus&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">miibus</span>(4)</span></a>
supported drivers that IEEE 802.3 auto-negotiation was performed in a wrong order, has
been fixed. Now it chooses the correct technologies supported by IEEE 802.3 in the order
described in Annex 28B.3.</p>

<p>[7.1R] A workaround has been added for a bug in TCP/UDP hardware checksum offload of
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
for short frames. Note that for frames that requires hardware VLAN tag insertion, the
checksum offload workaround does not work due to changes of checksum offset in mbuf after
the VLAN tag. So disabling hardware checksum offload for the VLAN interface is needed in
such cases.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndis&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndis</span>(4)</span></a> NDIS
miniport driver wrapper has been improved.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sf&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sf</span>(4)</span></a> driver has been
improved and now supports checksum offloading.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stge&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stge</span>(4)</span></a> driver
now supports WOL (Wake on LAN).</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vr&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">vr</span>(4)</span></a> driver has been
improved.</p>

<p>[7.1R] [amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wpi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wpi</span>(4)</span></a> driver
has been updated to include a number of stability fixes.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>The FreeBSD netisr framework has been reimplemented for parallel threading support.
This is a kernel network dispatch interface which allows device drivers (and other packet
sources) to direct packets to protocols for directly dispatched or deferred processing.
The new implementation supports up to one netisr thread per CPU, and several benchmarks
on SMP machines show substantial performance improvement over the previous version.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> that
EtherIP packets sent by combination of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> have a
reversed version field has been fixed. If you need to communicate with older FreeBSD
releases via EtherIP, use new flags <tt class="LITERAL">accept_rev_ethip_ver</tt> and <tt
class="LITERAL">send_rev_ethip_ver</tt> to control handling the reversed version field.
These can be set by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a>
interfaces. The EtherIP implementation found on FreeBSD 6.1, 6.2, 6.3, 7.0, 7.1, and 7.2
had an interoperability issue because it sent the incorrect EtherIP packets and discarded
the correct ones. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> manual
page.</p>

<p>The IGMPv3 and SSM (Source-Specific Multicast) including IPv6 SSM and MLDv2 have been
added. Although the old KAME MLDv2 hooks have been replaced with the new implementation,
the related kernel programming interfaces have been preserved.</p>

<p>The multicast routing code has been improved and the IPv4 and IPv6 support has been
split.</p>

<p>The FreeBSD now supports the upcoming Wireless Mesh standard, IEEE 802.11s. The
current implementation is based on the March 2009 D3.0 draft version.</p>

<p>The wireless network support layer (net80211) now uses pseudo-interfaces named as <tt
class="LITERAL">wlan<tt class="REPLACEABLE"><i>N</i></tt></tt> instead of a device driver
name like <tt class="LITERAL">em0</tt> directly. The <tt class="LITERAL">wlan<tt
class="REPLACEABLE"><i>N</i></tt></tt> interface is created by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> as
an instance of the parent interface and used for actual communication similar to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vlan&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vlan</span>(4)</span></a>, IEEE
802.1Q VLAN network interface. Note that multiple instances (to realize multiple BSSes
with a single AP device, for example) can be created if the parent interface supports it.
For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
manual page.</p>

<p>The net80211 layer now supports TDMA for long distance point-to-point links using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a>
devices.</p>

<p>An infrastructure for caching flows as a means of accelerating L2 and L3 lookups has
been added. This is called &#8220;flow table&#8221; and enabled by default on amd64 and
i386 platforms. This also provides stateful load balancing when used with <tt
class="LITERAL">RADIX_MPATH</tt></p>

<p>The FreeBSD L2 address translation table has been reimplemented to reduce lock
contention on parallel processing and simplify the routing logic. The new implementation
has L2 address translation tables for both ARP (for IPv4) and NDP (for IPv6) which are
separated from the L3 routing tables, and supports flow table caches for both the routing
table and the L2 information. One of the user-visible changes is that a concept of cloned
route (a route generated by an entry with <tt class="LITERAL">RTF_CLONING</tt> flag) is
deprecated. This means routing flags <tt class="LITERAL">RTF_CLONING</tt>, <tt
class="LITERAL">RTF_WASCLONE</tt>, and <tt class="LITERAL">RTF_LLINFO</tt> are
obsolete.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipsec&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipsec</span>(4)</span></a>
subsystem now supports NAT-Traversal (RFC 3948). This is disabled by default. To enable
this add the following kernel option and rebuild the kernel:</p>

<pre class="PROGRAMLISTING">
device crypto
options IPSEC
options IPSEC_NAT_T
</pre>

<p>[7.2R] IPv4 source address selection for unbound sockets has been implemented as
follows:</p>

<ol type="1">
<li>
<p>If we found a route, use the address corresponding to the outgoing interface.</p>
</li>

<li>
<p>[7.2R] Otherwise we assume the foreign address is reachable on a directly connected
network and try to find a corresponding interface to take the source address from.</p>
</li>

<li>
<p>[7.2R] As a last resort use the default jail address.</p>
</li>
</ol>

<p>[7.2R] This also changes the semantics of selecting the IP for processes within a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> as it
now uses the same logic as outside the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>.</p>

<p>[7.2R] The TCP MD5 Signature Option (RFC 2385) for IPv6 has been implemented in the
same way it has been implemented for IPv4.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_netflow</span>(4)</span></a>
Netgraph node now includes support for generating egress netflow instead or in addition
to ingress. An <tt class="LITERAL">NGM_NETFLOW_SETCONFIG</tt> control message has been
added to control the new functionality.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> Ethernet
tunnel software network interface now supports a new <tt class="LITERAL">TAPGIFNAME</tt>
character device ioctl. This is a convenient shortcut to obtain the network interface
name using a file descriptor to a character device.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> now
supports <tt class="LITERAL">SIOCSIFMTU</tt> ioctl to set a higher MTU than 1500
(ETHERMTU). This allows <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> devices
to be added to the same bridge (which requires all interface members to have the same
MTU) with an interface configured for jumbo frames.</p>

<p>[7.2R] The domains list for handling the list of supported domains in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unix&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unix</span>(4)</span></a> (UNIX
domain protocol family) subsystem is now MPSAFE.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a> utility
now supports <tt class="LITERAL">reject</tt> and <tt class="LITERAL">blackhole</tt>
keywords. In the entry marked as <tt class="LITERAL">reject</tt>, traffic to the host
will be discarded and the sender will be notified the host is unreachable. In the entry
marked as <tt class="LITERAL">blackhole</tt>, traffic is discarded but the sender is not
notified.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bpf</span>(4)</span></a> now
supports an ioctl <tt class="LITERAL">BIOCSETFNR</tt>. This is just like <tt
class="LITERAL">BIOCSETF</tt>, but it does not drop all the packets buffered on the
descriptor and reset the statistics.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a>
interface can limit the number of source MACs that can be behind a bridge interface via
<tt class="LITERAL">ifmaxaddr</tt> parameter of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>.</p>

<p>[7.1R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a>
interface configuration which leads to a system panic has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dummynet&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dummynet</span>(4)</span></a>
subsystem now supports <tt class="LITERAL">fast</tt> mode operation which allows certain
packets to bypass the dummynet scheduler. This can achieve lower latency and lower
overhead when the packet flow is under the pipe bandwidth, and eliminate recursion in the
subsystem. The new sysctl variable <code
class="VARNAME">net.inet.ip.dummynet.io_fast</code> has been added to enable this
feature.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=enc&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">enc</span>(4)</span></a> interface
now supports sysctl variables to control whether the firewalls or <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bpf</span>(4)</span></a> will see
inner and outer headers or just inner or outer headers for incoming and outgoing IPsec
packets.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gre&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gre</span>(4)</span></a> now
supports ioctls <tt class="LITERAL">GRESKEY</tt> and <tt class="LITERAL">GREGKEY</tt>
which allows set or get GRE key used for outgoing packets.</p>

<p>[7.1R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipsec&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipsec</span>(4)</span></a>
subsystem that PMTU was broken in those cases when there was a route with a lower MTU
than the MTU of the outgoing interface, has been fixed.</p>

<p>[7.1R] The netatm subsystem has been removed due to lacking multiprocessor
support.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_nat&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_nat</span>(4)</span></a> now
supports redirect functionality in <tt class="FILENAME">libalias</tt>. For more details,
see the manual page.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_pptpgre&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_pptpgre</span>(4)</span></a>
now supports multiple hooks like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_l2tp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_l2tp</span>(4)</span></a>, to
use one pair of pptpgre and ksocket nodes for all calls between two peers.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolver&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolver</span>(3)</span></a> now
allows underscore in domain names. Although this is a violation of RFC 1034 [STD 13], it
is accepted by certain name servers as well as other popular operating systems' resolver
library.</p>

<p>[7.1R] A socket option <tt class="LITERAL">TCP_CONGESTION</tt> for TCP sockets has
been added. This is for setting and retrieving the congestion control algorithm. The name
used is to allow compatibility with Linux.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rwlock&sektion=9&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rwlock</span>(9)</span></a> has
been used throughout the <code class="VARNAME">inpcbinfo</code> and <code
class="VARNAME">inpcb</code> infrastructure, and protocols that depend on that
infrastructure, including UDP, TCP, and IP raw sockets to reduce the lock
contentions.</p>

<p>[7.1R] The FreeBSD now supports multiple routing tables. To enable this, the following
steps are needed:</p>

<ul>
<li>
<p>Add the following kernel configuration option and rebuild the kernel. The <tt
class="LITERAL">2</tt> is the number of FIB (Forward Information Base, synonym for a
routing table here). The maximum value is 16.</p>

<pre class="PROGRAMLISTING">
options    ROUTETABLES=2
</pre>

<p>The procedure for rebuilding the FreeBSD kernel is described in the <a
href="http://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html#AEN30408"
target="_top">FreeBSD Handbook</a>.</p>

<p>This number can be modified on boot time. To do so, add the following to <tt
class="FILENAME">/boot/loader.conf</tt> and reboot the system:</p>

<pre class="PROGRAMLISTING">
net.fibs=6
</pre>
</li>

<li>
<p>Set a loader tunable <code class="VARNAME">net.my_fibnum</code> if needed. This means
the default number of routing tables. If not specified, <tt class="LITERAL">0</tt> will
be used.</p>
</li>

<li>
<p>Set a loader tunable <code class="VARNAME">net.add_addr_allfibs</code> if needed. This
enables to add routes to all FIBs for new interfaces by default. When this is set to <tt
class="LITERAL">0</tt>, it will only allocate routes on interface changes for the FIB of
the caller when adding a new set of addresses to an interface. Note that this tunable is
set to <tt class="LITERAL">1</tt> by default.</p>
</li>
</ul>

<p>To select one of the FIBs, the new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setfib&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">setfib</span>(1)</span></a>
utility can be used. This set an associated FIB with the process. For example:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> setfib -3 ping target.example.com
</pre>

<p>The FIB #3 will be used for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping</span>(8)</span></a>
command.</p>

<p>The FIB which the packet will be associated with will be determined in the following
rules:</p>

<ul>
<li>
<p>All packets which have a FIB associated with them will use the FIB. If not, FIB #0
will be used.</p>
</li>

<li>
<p>A packet received on an interface for forwarding uses FIB #0.</p>
</li>

<li>
<p>A TCP listen socket associated with an FIB will generate accept sockets which are
associated with the same FIB.</p>
</li>

<li>
<p>A packet generated in response to other packet uses the FIB associated with the packet
being responded to.</p>
</li>

<li>
<p>A packet generated on tunnel interfaces such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gif&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gif</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tun&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tun</span>(4)</span></a> will be
encapsulated using the FIB of the process which set up the tunnel.</p>
</li>

<li>
<p>Routing messages will be associated with the process's FIB.</p>
</li>
</ul>

<p>Also, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
supports an action rule <tt class="LITERAL">setfib</tt>. The following action:</p>

<pre class="PROGRAMLISTING">
setfib <tt class="REPLACEABLE"><i>fibnum</i></tt>
</pre>

<p>will make the matched packet use the FIB specified in <tt
class="REPLACEABLE"><i>fibnum</i></tt>. The rule processing continues at the next
rule.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The FreeBSD CAM SCSI subsystem (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a>) now
includes experimental support for ATA/SATA/AHCI-compliant devices. This is disabled by
default. To enable this, adding the following kernel options to your kernel configuration
file and rebuild the kernel:</p>

<pre class="PROGRAMLISTING">
device    ahci
device    siis
</pre>

<p>The current implementation supports AHCI-compliant controllers and SiliconImage
SiI3124/SiI3132/SiI3531 controllers. The device node of an ATA drive is <tt
class="LITERAL">ada</tt> and an ATAPI drive is <tt class="LITERAL">cd</tt>.</p>

<p>The FreeBSD iSCSI initiator implementation has been improved and supports IPv6.</p>

<p>A userland utility <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfiutil&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mfiutil</span>(8)</span></a> for
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mfi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mfi</span>(4)</span></a> devices
has been added. This includes basic features to monitor controller, array, and drive
status, change basic attributes, create/delete arrays and spares, and flush the
controller firmware. Note that this is a small utility, not a replacement of MegaCLI in
the Ports Collection which is supported officially and provides more functionality.</p>

<p>A userland utility <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mptutil&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mptutil</span>(8)</span></a> for
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpi&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mpi</span>(4)</span></a> devices
has been added. This includes basic features to monitor controller, array, and drive
status, change basic attributes, and create/delete arrays and spares.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=siis&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">siis</span>(4)</span></a> driver
has been added to provide support for SiliconImage SiI3124/3132/3531 SATA2 controllers.
It supports Serial ATA and ATAPI devices, port multipliers (including FIS-based
switching), hardware command queues (31 commands per port) and Native Command
Queuing.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports Marvell PATA M88SX6121.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now recognizes nForce MCP67 and MCP73 SATA controllers as AHCI.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
driver now includes preliminary support for DDF metadata found on Adaptec HostRAID
controllers. Note that spares and rebuilds are not supported yet.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a> SCSI
subsystem now supports a new sysctl variable <code
class="VARNAME">kern.cam.cd.retry_count</code>. This controls the number of retries for
the CD media. When trying to read scratched or damaged CDs and DVDs, the default
mechanism is sub-optimal, and programs like <b class="APPLICATION">ddrescue</b> do much
better if you turn off the retries entirely since their algorithms do it by themselves.
This value is set to <tt class="LITERAL">4</tt> (for a total of 5 attempts) by default.
Setting it to <tt class="LITERAL">0</tt> turns off all retry attempts.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ciss&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ciss</span>(4)</span></a> driver
which caused low &#8220;max device openings&#8221; count and led to poor performance has
been fixed.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glabel&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glabel</span>(8)</span></a> GEOM
class now supports a new UFS-based label called <tt class="LITERAL">ufsid</tt> that can
be used to reference UFS-carrying devices by the unique file system ID. This file system
ID is automatically generated and detected when the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glabel&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glabel</span>(8)</span></a> GEOM
class is enabled. An example of this new label is: <tt
class="FILENAME">/dev/ufsid/48e69c8b5c8e1b43</tt>. The benefit of using GEOM labels in
general is to avoid problems of device renaming when shifting drives or controllers.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gjournal&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gjournal</span>(8)</span></a> GEOM
class now supports the root file system. Previously, an unclean shutdown would make it
impossible to mount the root file system at boot.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> utility
has been updated. The APM scheme now supports Tivo Series 1 partitions (read only), a new
EBR scheme to support Extended Boot Records has been added, the BSD scheme now support
bootcode, and bugs in the PC98 and VTOC8 schemes have been fixed.</p>

<p>[7.2R] An issue in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> with
access permissions to underlying disks used by a gvinum plex has been fixed. If the plex
is a raid5 plex and is being written to, parity data might have to be read from the
underlying disks, requiring them to be opened for reading as well as writing.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptmv&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptmv</span>(4)</span></a> driver
has been updated to version 1.16 from HighPoint.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmc&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmc</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmcsd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmcsd</span>(4)</span></a> drivers
now support MMC and SDHC cards, high speed timing, wide bus, and multiblock
transfers.</p>

<p>[7.2R] [sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mpt</span>(4)</span></a> driver is
now in the <tt class="FILENAME">GENERIC</tt> kernel.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
has been added. This supports PCI devices with class 8 and subclass 5 according to the SD
Host Controller Specification.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
now supports kernel dumping and a sysctl variable <code
class="VARNAME">hw.sdhci.debug</code> for debug level.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
now supports 64-bit DMA.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmc&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmc</span>(4)</span></a> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmcsd&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmcsd</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
are now included as kernel modules.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=aac&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">aac</span>(4)</span></a> driver
now supports 64-bit array support for RAIDs larger than 2TB and simultaneous opens of the
device for issuing commands to the controller.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports a loader variable <code class="VARNAME">hw.ata.ata_dma_check_80pin</code>.
This can be used to disable the 80pin cable check on broken systems such as certain
laptops and Soekris boards. The default value is <tt class="LITERAL">1</tt>.</p>

<p>[7.1R] A data corruption problem of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver on
ServerWorks HT1000 chipsets has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ciss&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ciss</span>(4)</span></a> driver
now supports a loader tunable <code class="VARNAME">hw.ciss.nop_message_heartbeat</code>
for NOP-message polling in <code class="FUNCTION">ciss_periodic()</code>. This can be
used as a workaround for <tt class="LITERAL">ADAPTER HEARTBEAT FAILED</tt> issue. The
default value is <tt class="LITERAL">0</tt> (disabled).</p>

<p>[7.1R] The <tt class="FILENAME">geom_part</tt> GEOM class can be built as a kernel
module.</p>

<p>[7.1R] The <tt class="FILENAME">geom_linux_lvm</tt> GEOM class can be built as a
kernel module.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptrr&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptrr</span>(4)</span></a> driver
has been updated to version 1.2 from Highpoint.</p>

<p>[7.1R] A buffer overflow in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iir&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iir</span>(4)</span></a> driver
has been fixed. This likely fixes a great number of weird problems that have been
reported with this driver.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mpt</span>(4)</span></a> driver
now supports <tt class="LITERAL">mpt_user</tt> personality.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rr232x&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rr232x</span>(4)</span></a> driver
has been superseded by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptrr&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptrr</span>(4)</span></a>
driver.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
has been improved with regard to stability on machines with a plenty of memory and high
CPU load.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>&#8220;dangerously dedicated&#8221; mode for the UFS file system is no longer
supported.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Such disks will need to be reformatted to work with this
release.</p>
</blockquote>
</div>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> now
supports commands found in the old vinum implementation including <tt
class="COMMAND">attach</tt>, <tt class="COMMAND">detach</tt>, <tt
class="COMMAND">start</tt>, <tt class="COMMAND">stop</tt>, <tt
class="COMMAND">concat</tt>, <tt class="COMMAND">mirror</tt>, <tt
class="COMMAND">stripe</tt>, and <tt class="COMMAND">raid5</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> now
supports <tt class="LITERAL">grow</tt> command to make it easier for users to extend
plexes without having to understand all of the implementation internals.</p>

<p>The FreeBSD NFS subsystem now supports <tt class="LITERAL">RPCSEC_GSS</tt>
authentication on both the client and server. This replaces the RPC implementation of the
NFS client and server with the newer RPC implementation originally developed to support
the NFS Lock Manager. It supports both the new RPC implementation and the older legacy
implementation inherited from the original NFS codebase and the default is to use the new
one. To use <tt class="LITERAL">RPCSEC_GSS</tt> on either client or server, you must
build a kernel which includes the <tt class="LITERAL">KGSSAPI</tt> option and the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crypto&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crypto</span>(4)</span></a>
device. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gssd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gssd</span>(8)</span></a> manual
page.</p>

<p>The FreeBSD NFS subsystem now includes a new, experimental implementation with support
for NFSv2, NFSv3, and NFSv4. This is not enabled by default. To enable this, add the
following kernel options to your kernel configuration file and rebuild the kernel:</p>

<pre class="PROGRAMLISTING">
options    NFSCL   # for NFS client
options NFSD    # for NFS server
</pre>

<p>The fstype for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> program
is <tt class="LITERAL">newnfs</tt>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_newnfs&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_newnfs</span>(8)</span></a>
program has also been added. The old, unmaintained NFSv4 client based on an
implementation from the University of Michigan was removed from the FreeBSD source
tree.</p>

<p>The FreeBSD NFS subsystem now uses TCP as the default transport.</p>

<p>The shared vnode locking for pathname lookups in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=VFS&sektion=9&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">VFS</span>(9)</span></a> subsystem
has been improved. This is enabled by default. Setting a sysctl variable <code
class="VARNAME">vfs.lookup_shared</code> to <tt class="LITERAL">0</tt> disables it. Note
that the <tt class="LITERAL">LOOKUP_SHARED</tt> kernel option equivalent to the sysctl
variable has been removed.</p>

<p>The <b class="APPLICATION">ZFS</b> file system has been updated to version 13. The
changes include ZFS operations by a regular user, L2ARC, ZFS Intent Log on separated
disks (slog), sparse volumes, and so on.</p>

<p>[7.2R] The semantics of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acl&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acl</span>(3)</span></a> extended
access control lists has been changed as follows:</p>

<ul>
<li>
<p>The inode modification time (mtime) is not updated when extended attributes are added,
modified, or removed.</p>
</li>

<li>
<p>The inode access time (atime) is not updated when extended attributes are queried.</p>
</li>
</ul>

<p>[7.2R] The FreeBSD NFS file system now supports a sysctl variable <code
class="VARNAME">vfs.nfs.prime_access_cache</code> to determine whether or not <code
class="FUNCTION">nfs_getattr()</code> will use an ACCESS RPC to prime the access cache
instead of a simple GETATTR RPC. This is because on many NFS servers an ACCESS RPC is
much more expensive to service than a GETATTR RPC for files in an NFSv3 mount. The sysctl
variable is enabled by default to maintain the previous behavior.</p>

<p>[7.2R] The FreeBSD UDF file system now supports a fifo.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdescfs&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdescfs</span>(5)</span></a> is
now MPSAFE.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> now
supports BSD disklabels (option <tt class="LITERAL">GEOM_PART_BSD</tt>) and VTOC8
disklabels (option <tt class="LITERAL">GEOM_PART_VTOC8</tt>).</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> now
accepts <tt class="REPLACEABLE"><i>volume</i></tt> parameter when creating a plex.</p>

<p>[7.1R] A pathname lookup bug of a UNIX domain socket in the <tt
class="FILENAME">unionfs(7)</tt> has been fixed.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The GCC stack protection (also known as ProPolice) has been enabled in the FreeBSD
base system.</p>

<p>A BSD-licensed <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ar&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ar</span>(1)</span></a> utility has
been added in favor of one in <b class="APPLICATION">GNU binutils</b> and it is now the
default utility for building the FreeBSD base system.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=awk&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">awk</span>(1)</span></a> utility
now supports 64 files. The upper limit was 20 in prior releases.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsnmpd&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsnmpd</span>(1)</span></a>
program now supports OIDs for ZFS.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=camcontrol&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">camcontrol</span>(8)</span></a>
program now supports a new modularized ATA kernel module and various ATA commands.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cat</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> now use a
larger buffer if the number of pages of the physical memory on the system is grater than
32k. This reduces the number of context switches.</p>

<p>A new BSD-licensed <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpio&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpio</span>(1)</span></a> utility
has been added in favor of <b class="APPLICATION">GNU cpio</b> and it is now the default
utility in the FreeBSD base system.</p>

<p>A script for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crashinfo&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crashinfo</span>(8)</span></a>
utility for simple analysis of crash dump has been added. It generates a text file
containing the output of several commands run against the core dump such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> (stack
trace), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ps</span>(1)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vmstat&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vmstat</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iostat&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iostat</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dmesg&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dmesg</span>(8)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fstat</span>(1)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=df&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">df</span>(1)</span></a> utility's <code
class="OPTION">-h</code> flag now supports displaying inode counts in a human-readable
format when a flag <code class="OPTION">-i</code> is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=df&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">df</span>(1)</span></a> utility now
supports a <code class="OPTION">-T</code> flag to display file system type in each
entry.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> that
can create a malformed <tt class="FILENAME">/etc/resolv.conf</tt> has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
uses an <code class="OPTION">-n</code> flag when invoking <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=route&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">route</span>(8)</span></a>
command. This eliminates a long delay in the case that it gets a lease but DNS service is
not working.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
utility now uses <tt class="LITERAL">68</tt> (bootpc) as the source port for unicast <tt
class="LITERAL">DHCPREQUEST</tt> packets instead of allowing the protocol stack to pick a
random source port. This fixes the behavior where <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a>
would never transition from <tt class="LITERAL">RENEWING</tt> to <tt
class="LITERAL">BOUND</tt> without going through <tt class="LITERAL">REBINDING</tt> in
some networks which has a tight policy on DHCP spoofing.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=env&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">env</span>(1)</span></a> utility
now supports a <code class="OPTION">-u <tt class="REPLACEABLE"><i>name</i></tt></code>
option that completely unsets the given name instead of setting it to a null value.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=find&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">find</span>(1)</span></a> utility
now supports a number of primaries found in <b class="APPLICATION">GNU find</b> including
<code class="OPTION">-ignore_readdir_race</code>, <code
class="OPTION">-noignore_readdir_race</code>, <code class="OPTION">-noleaf</code>, <code
class="OPTION">-gid</code>, <code class="OPTION">-uid</code>, <code
class="OPTION">-wholename</code>, <code class="OPTION">-iwholename</code>, <code
class="OPTION">-mount</code>, <code class="OPTION">-d</code>, <code
class="OPTION">-lname</code>, <code class="OPTION">-ilname</code>, <code
class="OPTION">-quit</code>, <code class="OPTION">-samefile</code>, and <code
class="OPTION">-true</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> utility
now supports a <code class="OPTION">-r</code> flag to free up excess unused inodes.
Decreasing the number of preallocated inodes reduces the running time of future runs of
fsck and frees up space that can allocated to files. This flag is ignored when running in
preen mode.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> now supports backing up the old
kernel when installing a new kernel. The backup kernel will be written to <tt
class="FILENAME">/boot/kernel.old</tt> if the directory does not exist or the directory
was created by freebsd-update in a previous backup. Otherwise the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> will generate a new directory
name for use by the backup. This is enabled by default.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gdbserver&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gdbserver</span>(1)</span></a> now
supports arm and powerpc platforms.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a> program
has been removed in favor of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gzip&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gzip</span>(1)</span></a> utility
now supports uncompressing files which are created by <b class="APPLICATION">pack</b>
found in some commercial UNIX-like systems.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=i2c&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">i2c</span>(8)</span></a> utility
for diagnostics of I2C has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> now
supports <code class="OPTION">vnet</code> and <code class="OPTION">-vnet</code> option to
allow moving interfaces between jails with vimage.</p>

<p>A BSD-licensed <tt class="FILENAME">libdwarf</tt> library has been added for DTrace
clients.</p>

<p>The <tt class="FILENAME">libmsun</tt> library now supports <code
class="FUNCTION">acosl()</code>, <code class="FUNCTION">asinl()</code>, <code
class="FUNCTION">atanl()</code>, <code class="FUNCTION">atan2l()</code>, <code
class="FUNCTION">cargl()</code>, <code class="FUNCTION">csqrtl()</code>, <code
class="FUNCTION">fmodl()</code>, <code class="FUNCTION">hypotl()</code>, and <code
class="FUNCTION">remquol()</code> functions.</p>

<p>The <tt class="FILENAME">libproc</tt> library has been added for DTrace clients.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mtest&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mtest</span>(8)</span></a> utility
now supports IPv6.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> program
now supports an <code class="OPTION">-o mountprog=<tt
class="REPLACEABLE"><i>filename</i></tt></code> option to allow an alternative program to
be used for mounting a file system. This is useful for non-<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nmount&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nmount</span>(2)</span></a> based
file systems such as FUSE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfscbd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfscbd</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfsuserd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfsuserd</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfsdumpstate&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfsdumpstate</span>(8)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfsrevoke&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfsrevoke</span>(8)</span></a>
utilities for the new NFSv4 subsystem has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcannotate&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmcannotate</span>(8)</span></a>
utility has been added. This prints out sources of a tool (in C or assembly) with inlined
profiling informations retrieved by a prior <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmcstat&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pmcstat</span>(8)</span></a>
analysis.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=route&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">route</span>(8)</span></a> utility
now supports <tt class="COMMAND">show</tt>, <tt class="COMMAND">weights</tt>, and <tt
class="COMMAND">sticky</tt> commands. For more details, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=route&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">route</span>(8)</span></a> manual
page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> now
supports a new environment variable <code class="VARNAME">LD_ELF_HINTS_PATH</code> for
overriding the rtld hints file. This environment variable would be ignored if the process
uses setuid and/or setgid. This feature gives a convenient way to use a custom set of
shared library that is not in the default location.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> now
supports the dynamic string token substitution in the rpath and soneeded pathes. The
<code class="VARNAME">$ORIGIN</code>, <code class="VARNAME">$OSNAME</code>, <code
class="VARNAME">$OSREL</code> and <code class="VARNAME">$PLATFORM</code> tokens are
supported. Enabling the substitution requires <tt class="LITERAL">DF_ORIGIN</tt> flag in
<tt class="LITERAL">DT_FLAGS</tt> or <tt class="LITERAL">DF_1_ORIGIN</tt> if <tt
class="LITERAL">DF_FLAGS_1</tt>, that may be set with <code class="OPTION">-z</code>
origin <b class="APPLICATION">GNU ld</b> flag. This translation is unconditionally
disabled for setuid/setgid processes. The <code class="VARNAME">$ORIGIN</code>
translation relies on the <tt class="LITERAL">AT_EXECPATH</tt> auxinfo supplied by the
FreeBSD kernel.</p>

<p>It is no longer possible to create UFS filesystems in &#8220;dangerously
dedicated&#8221; mode using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
since this mode is no longer supported.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menus have been simplified to reduce confusion and duplication with other parts of the
system. The <b class="APPLICATION">Xorg</b> window system should be installed just like
any other package. Configuration of <b class="APPLICATION">Linux</b> and <b
class="APPLICATION">OSF/1</b> emulation should be done via kernel rebuilds. Support for
installation from tape media was removed as it was believed to be broken. Obsolete code
to support <tt class="LITERAL">OLDCARD</tt> was also removed.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
now understands how to use unsliced USB drives as installation source media via <tt
class="FILENAME">/dev/da<tt class="REPLACEABLE"><i>X</i></tt><tt
class="REPLACEABLE"><i>a</i></tt></tt></p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
now recognizes the new <tt class="FILENAME">/dev/ada<tt
class="REPLACEABLE"><i>X</i></tt></tt> disk devices, if compiled into the kernel.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
now uses the <tt class="FILENAME">freebsd-doc-<tt class="REPLACEABLE"><i>*</i></tt></tt>
packages for localized documents.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
now ejects the CDROM after installation if it was used as source media.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute</span>(8)</span></a>
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute6</span>(8)</span></a>
now support an <code class="OPTION">-a</code> flag to display AS number corresponding to
the lookup IP address on each hop. It will query the number to WHOIS server specified in
<code class="OPTION">-A</code> option. If no <code class="OPTION">-A</code> is specified,
<tt class="HOSTID">whois.radb.net</tt> will be used as the default value.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tzsetup&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tzsetup</span>(8)</span></a> now
supports an <code class="OPTION">-s</code> flag to skip the question about adjusting the
clock to UTC.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wake&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wake</span>(8)</span></a> utility,
a tool to send Wake on LAN frames to hosts on a local Ethernet network has been
added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ypserv&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ypserv</span>(8)</span></a>
program now supports <tt class="FILENAME">shadow.byname</tt> and <tt
class="FILENAME">shadow.byuid</tt> maps.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility, which prevents it from working when <tt class="FILENAME">/usr</tt> is not
mounted or invoked from <tt class="FILENAME">/rescue</tt>, has been fixed.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=btpand&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">btpand</span>(8)</span></a> daemon
from NetBSD has been added. This daemon provides support for Bluetooth Network Access
Point (NAP), Group Ad-hoc Network (GN) and Personal Area Network User (PANU)
profiles.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpucontrol&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpucontrol</span>(8)</span></a>
utility has been added to control <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a>
pseudo-device.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ncal&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ncal</span>(1)</span></a> utility
now supports multibyte characters.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
now supports operations on a regular file.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=config&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">config</span>(8)</span></a>
utility now supports multiple <code class="VARNAME">makeoption</code> lines.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=csup&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">csup</span>(1)</span></a> utility
now supports CVSMode to fetch a complete CVS repository. Note that the rsync transfer
mode is currently disabled.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dirname&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dirname</span>(1)</span></a>
utility now accepts multiple arguments in the same way that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=basename&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">basename</span>(1)</span></a>
does.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports an <code class="OPTION">-l</code> flag. When specified, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility counts
a file with multiple hard links as multiple different files.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports an <code class="OPTION">-A</code> flag to display the apparent size instead of
the disk usage. This can be helpful when operating on compressed volumes or sparse
files.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports a <code class="OPTION">-B <tt class="REPLACEABLE"><i>blocksize</i></tt></code>
option to calculate block counts in blocks of <tt
class="REPLACEABLE"><i>blocksize</i></tt> bytes. This is different from the <code
class="OPTION">-k</code> or <code class="OPTION">-m</code> options or setting <code
class="VARNAME">BLOCKSIZE</code> and gives an estimate of how much space the examined
file hierarchy would require on a file system with the given <tt
class="REPLACEABLE"><i>blocksize</i></tt>. Unless in <code class="OPTION">-A</code> mode,
<tt class="REPLACEABLE"><i>blocksize</i></tt> is rounded up to the next multiple of
512.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dumpfs&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dumpfs</span>(8)</span></a>
utility now supports an <code class="OPTION">-f</code> flag, which causes it to list all
free fragments in the file system by fragment (block) number. This new mode does the
necessary arithmetic to generate absolute fragment numbers rather than the cg-relative
numbers printed in the default mode.</p>

<p>[7.2R] If <code class="OPTION">-f</code> is passed once, contiguous fragment ranges
are collapsed into an X-Y format as free block lists are currently printed in regular
dumpfs output. If specified twice, all block numbers are printed individually, allowing
both compact and more script-friendly representation.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> utility
now supports an <code class="OPTION">-i</code> flag which supports the If-Modified-Since
HTTP 1.1 request. If specified it will cause the file to be downloaded only if it is more
recent than the mtime of the local file. Also, <b class="APPLICATION">libfetch</b> now
accepts the mtime in the url structure and a flag to indicate when this behavior is
desired.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> utility
now supports a <code class="OPTION">-C</code> flag for <tt class="LITERAL">check
clean</tt> mode. This checks if the file system was dismounted cleanly first and then
skip file system checks if true. Otherwise it does full checks.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> utility
now supports a <code class="OPTION">-D</code> flag for damaged recovery mode, which will
enable certain aggressive operations that can make <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> to
survive with file systems that has very serious data damage. This is a useful last resort
when on disk data damage is very serious and causes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> to
crash.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>
function now supports SCTP.</p>

<p>[7.2R] A bug was fixed in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> utility
which displays extra messages for a NAT rule even when a <code class="OPTION">-q</code>
flag is specified.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> utility now
supports a <code class="OPTION">-w</code> flag to check if the source file actually
exists. When the flag is specified and the file does not exist, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> will issue a
warning message.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> utility now
allows creating hard links to symbolic links because the POSIX.1-2008 requires this
behavior for <code class="OPTION">-L</code> and <code class="OPTION">-P</code> flag.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lpr&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lpr</span>(1)</span></a> utility
now support an <code class="OPTION">-m</code> flag to send an email after the job is
completed and a <code class="OPTION">-t</code> option to set the job title.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports a <code class="OPTION">-p</code> flag to print the input graph only, without
executing any commands. The output is the same as <code class="OPTION">-d g1</code>. When
combined with <code class="OPTION">-f /dev/null</code>, only the built-in rules of make
are displayed.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports a <code class="OPTION">-Q</code> flag to cause file banners not to be
generated in addition to the same effect of a <code class="OPTION">-q</code> flag when a
<code class="OPTION">-j</code> option is specified.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports the <code class="VARNAME">.MAKE.JOB.PREFIX</code> variable. If <code
class="OPTION">-j</code> and <code class="OPTION">-v</code> are specified, its output for
each target is prefixed with a token <tt class="LITERAL">--- <tt
class="REPLACEABLE"><i>target</i></tt> ---</tt> the first part of which can be controlled
via the variable.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports <code class="VARNAME">.MAKE.PID</code> and <code
class="VARNAME">.MAKE.PPID</code> variable. These are set to process ID of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> process
and its parent process respectively.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=makefs&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">makefs</span>(8)</span></a>
utility to create a file system image from a directory tree has been added.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
utility now supports an <code class="OPTION">-F</code> option to automatically install
files that differ only in their version control ID strings.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> utility
now supports an <code class="OPTION">-o mountprog=<tt
class="REPLACEABLE"><i>/somewhere/mount_xxx</i></tt></code> option to force it to use the
specified program to mount the file system instead of calling <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nmount&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nmount</span>(2)</span></a>
directly. This is useful when you want to use third party programs such as FUSE, for
example.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility now reports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unix&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unix</span>(4)</span></a> sockets'
listen queue statistics when an <code class="OPTION">-L</code> flag is specified.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility has been fixed. It crashed with the following options in the previous
versions:</p>

<pre class="SCREEN">
<samp class="PROMPT">%</samp> netstat -m -N foo
</pre>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility has been fixed. The <code class="OPTION">-ss</code> option now works in the icmp6
section as expected.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pciconf&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pciconf</span>(8)</span></a>
utility now supports a <code class="OPTION">-b</code> flag, which lists any base address
registers (BAR) that are assigned resources for each device.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=powerd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">powerd</span>(8)</span></a>
program has been improved. Changes include reasonable CPU load estimation on SMP systems
and a new mode named as <tt class="LITERAL">hiadaptive</tt> for AC-powered systems. The
<tt class="LITERAL">hiadaptive</tt> mode raises the CPU frequency twice as fast as <tt
class="LITERAL">adaptive</tt>, it drops the CPU frequency 4 times slower, prefers twice
lower CPU load and has an additional delay before leaving the highest frequency after the
period of maximum load.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=revoke&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">revoke</span>(1)</span></a>
utility has been added. This is a wrapper of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=revoke&sektion=2&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">revoke</span>(2)</span></a>
syscall.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stat&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stat</span>(1)</span></a> utility
now displays an octal representation of suid, sgid and sticky bits when the <code
class="OPTION">-x</code> flag is specified.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strndup&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strndup</span>(3)</span></a>
function has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tftpd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tftpd</span>(8)</span></a> program
now supports a <code class="OPTION">-W</code> option. This is almost the same as a <code
class="OPTION">-w</code> option but will generate unique named based on the submitted
filename, a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strftime&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strftime</span>(3)</span></a>
format string, and a two digit sequence number. The time format string can be set by an
<code class="OPTION">-F</code> option.</p>

<p>[7.2R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wc&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">wc</span>(1)</span></a> utility now
supports an <code class="OPTION">-L</code> flag to output the number of characters in the
longest input line.</p>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.yppasswdd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.yppasswdd</span>(8)</span></a>
program, which causes it to leave a zombie process when a password or default shell is
changed, has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=adduser&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">adduser</span>(8)</span></a>
utility now supports a <code class="OPTION">-M</code> option to set the mode of a new
user's home directory.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility now supports a <tt class="COMMAND">spindown</tt> command to set or report timeout
after which the device will be spun down.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a> now
supports a <code class="OPTION">-v</code> flag for verbose output, a <code
class="OPTION">-f</code> flag to ignore errors, and <code class="OPTION">-h</code> to
allow setting flags on symbolic links with the same semantics as (for example) <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chmod&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chmod</span>(1)</span></a>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> now supports a
<code class="OPTION">-a</code> flag, which is equivalent to <code
class="OPTION">-RpP</code> flags.</p>

<p>[7.1R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> utility which
prevents POSIX.1e ACL (see also <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acl&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acl</span>(3)</span></a>) from
copying properly has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cron&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cron</span>(8)</span></a> utility
now supports <code class="OPTION">-m</code> flag which overrides the default mail
recipient for cron mails unless explicitly provided by <tt class="LITERAL">MAILTO=</tt>
line in <tt class="FILENAME">crontab</tt> file.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
supports more options described in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhcp-options&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">dhcp-options</span>(5)</span></a>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
supports <code class="FUNCTION">is_default_interface()</code> function which determines
if this interface is one with the default route.</p>

<p>[7.1R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> that
prevents removal of the default route from working has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=environ&sektion=7&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">environ</span>(7)</span></a>,
environment array of strings now supports unsetting a variable by setting the first
character to NULL. This is required by third-party software such as <b
class="APPLICATION">Dovecot</b> and <b class="APPLICATION">Postfix</b>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdisk&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdisk</span>(8)</span></a> now
supports a <code class="OPTION">-q</code> flag to not display any warnings.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> program
and <tt class="FILENAME">libfetch</tt> library now supports a <code
class="VARNAME">NO_PROXY</code> environment variable. This specifies comma- or
whitespace-separated list of host names for which proxies should not be used. If a single
asterisk is specified, the use of proxies is disabled.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffsll&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffsll</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=flsll&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">flsll</span>(3)</span></a>
functions have been added. These functions are the same as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffs&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffs</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fls&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fls</span>(3)</span></a> except
that they accept long long as the arguments.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fortune&sektion=6&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fortune</span>(6)</span></a>
program now supports <code class="VARNAME">FORTUNE_PATH</code> environment variable to
specify search path of the fortune files.</p>

<p>[7.1R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fortune&sektion=6&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fortune</span>(6)</span></a>
program that prevents <code class="OPTION">-e</code> option with multiple files from
working has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update.conf&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update.conf</span>(5)</span></a> now supports <tt
class="LITERAL">IDSIgnorePaths</tt> statement.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fwcontrol&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fwcontrol</span>(8)</span></a>
utility now supports <code class="OPTION">-f <tt
class="REPLACEABLE"><i>node</i></tt></code> option which specifies <tt
class="REPLACEABLE"><i>node</i></tt> as the root node on the next bus reset.</p>

<p>[7.1R] [sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gcc&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gcc</span>(1)</span></a> now
accepts <code class="OPTION">-mcpu</code> option properly; it was hardcoded as <code
class="OPTION">-mcpu=ultrasparc</code>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
command now supports display of WPS IE (Wireless Provisioning Services Information
Element).</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> command
now supports an <tt class="COMMAND">add-kld <tt class="REPLACEABLE"><i>kld</i></tt></tt>
command to locate a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> and load
its symbols.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> command
now has a shared library backend for kernel files that treats <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> as shared
libraries and auto-loading symbols for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> on
startup.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> now
supports a <tt class="COMMAND">tid</tt> command and other kernel module related commands
even for a remote target.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kvm_getcptime&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kvm_getcptime</span>(3)</span></a>
function to obtain the global CPU time statistics from the kernel has been added.</p>

<p>[7.1R] The <tt class="FILENAME">libalias</tt> library now supports <tt
class="LITERAL">PORT</tt> and <tt class="LITERAL">EPRT</tt> FTP commands in
lowercase.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=man&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">man</span>(1)</span></a> now
includes a limited support of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bzip2&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">bzip2</span>(1)</span></a>-compressed manual pages.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mdconfig&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mdconfig</span>(8)</span></a>
command now supports a <code class="OPTION">-v</code> (verbose) flag to <code
class="OPTION">-l</code> command. It shows size and backing store of all <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=md&sektion=4&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">md</span>(4)</span></a> devices at one
time.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memrchr&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memrchr</span>(3)</span></a>
function has been added. This behaves like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memchr&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memchr</span>(3)</span></a> except
that it locates the last occurrence of the specified character in the string.</p>

<p>[7.1R] The incorrect output grammar of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=morse&sektion=6&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">morse</span>(6)</span></a> program
has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mountd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mountd</span>(8)</span></a>
utility now supports <code class="OPTION">-h <tt
class="REPLACEABLE"><i>bindip</i></tt></code> option which specifies IP addresses to bind
to for TCP and UDP requests. This option may be specified multiple times. If no <code
class="OPTION">-h</code> option is specified, <tt class="LITERAL">INADDR_ANY</tt> will be
used. Note that when specifying IP addresses with this option, it will automatically add
<tt class="LITERAL">127.0.0.1</tt> and if IPv6 is enabled, <tt class="LITERAL">::1</tt>
to the list.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=moused&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">moused</span>(8)</span></a>
utility now supports <code class="OPTION">-L</code> flag which changes the speed of
scrolling and changes <code class="OPTION">-U</code> option behavior to only affect the
scroll threshold.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mv&sektion=1&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">mv</span>(1)</span></a> command now
support POSIX specification when moving a directory to an existing directory across
devices.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">periodic</span>(8)</span></a> now
supports <code class="VARNAME">daily_status_mail_rejects_shorten</code> configuration
variable in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic.conf&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">periodic.conf</span>(5)</span></a>. This allows the rejected mail
reports to tally the rejects per blacklist without providing details about individual
sender hosts. The default configuration keeps the reports in their original form.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
uses exit status of <tt class="LITERAL">0</tt> and <tt class="LITERAL">2</tt> in the same
manner as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping</span>(8)</span></a>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
supports an <code class="OPTION">-o</code> flag, which makes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> exit
successfully after receiving one reply packet.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
supports <code class="OPTION">-r</code> and <code class="OPTION">-R</code> flags, which
are equivalent to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping</span>(8)</span></a>'s <code
class="OPTION">-a</code> and <code class="OPTION">-A</code> flags, respectively.</p>

<p>[7.1R] The minimum allowed interval of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> has
been decreased to 0.000001 from 0.01.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=realpath&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">realpath</span>(1)</span></a>
utility now supports a <code class="OPTION">-q</code> flag to suppress warnings and
accepts multiple paths on its command line.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rfcomm_pppd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rfcomm_pppd</span>(8)</span></a>
now supports a <code class="OPTION">-D</code> flag to register DUN (Dial-Up Networking)
service in addition to the LAN (LAN Access Using PPP) service.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdpd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdpd</span>(8)</span></a> now
supports a <tt class="LITERAL">NAP</tt>, <tt class="LITERAL">GN</tt>, and <tt
class="LITERAL">PANU</tt> profiles.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setkey&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">setkey</span>(8)</span></a>
utility now accepts <tt class="LITERAL">esp</tt> as a protocol name for the <tt
class="COMMAND">spdadd</tt> command.</p>

<p>[7.1R] A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnetd&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnetd</span>(8)</span></a> that
caused it to attempt authentication even when <code class="OPTION">-a off</code> option
is specified has been fixed.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=top&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">top</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vmstat&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vmstat</span>(8)</span></a>
commands now support <code class="OPTION">-P</code> flag which displays per-CPU
statistics.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_enc_le&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_enc_le</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_dec_le&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_dec_le</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_enc_be&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_enc_be</span>(3)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_dec_be&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_dec_be</span>(3)</span></a>
functions have been added. These functions encode/decode a binary representation of a
UUID.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=watch&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">watch</span>(8)</span></a> utility
now supports more than 10 <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snp&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snp</span>(4)</span></a> devices
at a time.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ypserv&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ypserv</span>(8)</span></a> daemon
now supports a <code class="OPTION">-P</code> option to specify the port number on which
it should listen.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports <code class="VARNAME">dummynet_enable</code> variable which allow <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dummynet&sektion=4&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dummynet</span>(4)</span></a>
kernel module to be loaded when <code class="VARNAME">firewall_enable</code> is <tt
class="LITERAL">YES</tt>.</p>

<p>[7.1R] The <tt class="FILENAME">ntpd</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script can work
with no configuration file <tt class="FILENAME">/etc/ntp.conf</tt> now.</p>

<p>[7.1R] The <tt class="FILENAME">ppp</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script now
supports multiple instances. For more details, see the description of <code
class="VARNAME">ppp_profile</code> variable in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a>.</p>

<p>[7.1R] The <tt class="FILENAME">sysctl</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+8.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script now
supports loading <tt class="FILENAME">/etc/sysctl.conf.local</tt> in addition to <tt
class="FILENAME">/etc/sysctl.conf</tt>.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports configuration of interfaces and attached networks for firewall rule set by <tt
class="FILENAME">rc.firewall</tt> when <code class="VARNAME">firewall_type</code> is <tt
class="LITERAL">simple</tt> or <tt class="LITERAL">client</tt>. See <code
class="VARNAME">firewall_client_net</code>, <code
class="VARNAME">firewall_simple_iif</code>, <code
class="VARNAME">firewall_simple_inet</code>, <code
class="VARNAME">firewall_simple_oif</code>, and <code
class="VARNAME">firewall_simple_onet</code>.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.6.1rc1.</p>

<p>The <b class="APPLICATION">ACPI-CA</b> has been updated to 20090521.</p>

<p>The <b class="APPLICATION">ee</b> (easy editor) has been updated to 1.5.0. This
version is now licensed under a 2-clause BSD license, instead of the Artistic
license.</p>

<p>The <b class="APPLICATION">hostapd</b> has been updated to version 0.6.8 + radius ACL
support.</p>

<p>The <b class="APPLICATION">less</b> has been updated to version v436.</p>

<p>The <tt class="FILENAME">libarchive</tt> library has been updated to version
2.7.0.</p>

<p>The <tt class="FILENAME">libexpat</tt> library has been updated from version 1.95.5 to
version 2.0.1.</p>

<p>The <tt class="FILENAME">ncurses</tt> library has been updated to version
5.7-20081102.</p>

<p><b class="APPLICATION">OpenBSM</b> 1.1 from Trusted BSD Project has been merged.</p>

<p><b class="APPLICATION">TCPDUMP</b> has been updated to 4.0.0.</p>

<p>The timezone database has been updated to the <b class="APPLICATION">tzdata2009f</b>
release.</p>

<p><b class="APPLICATION">wpa_supplicant</b> has been updated to version 0.6.8</p>

<p>The <b class="APPLICATION">ZFS</b> file system has been updated from version 6 to
version 13.</p>

<p>[7.1R] The <b class="APPLICATION">am-utils</b> has been updated from version 6.0.10p1
to version 6.1.5.</p>

<p>[7.1R] The <b class="APPLICATION">awk</b> has been updated from 1 May 2007 release to
the 23 October 2007 release.</p>

<p>[7.1R] The <b class="APPLICATION">bzip2</b> has been updated from version 1.0.4 to
version 1.0.5.</p>

<p>[7.1R] The <b class="APPLICATION">CVS</b> has been updated to version 1.11.22.1.</p>

<p>[7.1R] <b class="APPLICATION">NTP</b> has been updated to version 4.2.4p5.</p>

<p>[7.1R] <b class="APPLICATION">OpenPAM</b> has been updated from the Figwort release to
the Hydrangea release.</p>

<p>[7.1R] <b class="APPLICATION">OpenSSH</b> has been updated from version 4.5p1 to
version 5.1p1.</p>

<p>[7.1R] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolver&sektion=3&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolver</span>(3)</span></a>
library has been updated to one of <b class="APPLICATION">ISC BIND</b> 9.4.3.</p>

<p>[7.1R] <b class="APPLICATION">sendmail</b> has been updated from version 8.14.2 to
version 8.14.3.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>[7.2R] A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_create</span>(1)</span></a>
utility, which prevented the <code class="OPTION">-n</code> flag from working has been
fixed.</p>

<p>[7.2R] The FreeBSD Ports Collection now supports multiple <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> jobs in
some supported ports. This is automatically enabled when a port is marked as <code
class="VARNAME">MAKE_JOBS_SAFE</code> and improves CPU utilization at the build stage by
passing an option <code class="OPTION">-j<tt class="REPLACEABLE"><i>X</i></tt></code> to
the top level <tt class="FILENAME">Makefile</tt> from the vendor. The number <tt
class="REPLACEABLE"><i>X</i></tt> is set to the number of CPUs by default, and can be set
by users via a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> variable
<code class="VARNAME">MAKE_JOBS_NUMBER</code>. For more details, see <tt
class="FILENAME">ports/Mk/bsd.port.mk</tt>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated to 2.26.3.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde4/pkg-descr"><tt
class="FILENAME">x11/kde4</tt></a>) has been updated to 4.3.1.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Upgrades between RELEASE versions (and snapshots of the various security
branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC or SMP
kernels distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded has Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="COMMAND">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+8.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


